# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudfront
using AWS.Compat
using AWS.UUIDs
"""
    CreateCachePolicy2020_05_31()

Creates a cache policy. After you create a cache policy, you can attach it to one or more cache behaviors. When it’s attached to a cache behavior, the cache policy determines the following:   The values that CloudFront includes in the cache key. These values can include HTTP headers, cookies, and URL query strings. CloudFront uses the cache key to find an object in its cache that it can return to the viewer.   The default, minimum, and maximum time to live (TTL) values that you want objects to stay in the CloudFront cache.   The headers, cookies, and query strings that are included in the cache key are automatically included in requests that CloudFront sends to the origin. CloudFront sends a request when it can’t find an object in its cache that matches the request’s cache key. If you want to send values to the origin but not include them in the cache key, use OriginRequestPolicy. For more information about cache policies, see Controlling the cache key in the Amazon CloudFront Developer Guide.

# Required Parameters
- `CachePolicyConfig`: A cache policy configuration.

"""

create_cache_policy2020_05_31(CachePolicyConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/cache-policy", Dict{String, Any}("CachePolicyConfig"=>CachePolicyConfig); aws_config=aws_config)
create_cache_policy2020_05_31(CachePolicyConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/cache-policy", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("CachePolicyConfig"=>CachePolicyConfig), args)); aws_config=aws_config)

"""
    CreateCloudFrontOriginAccessIdentity2020_05_31()

Creates a new origin access identity. If you're using Amazon S3 for your origin, you can use an origin access identity to require users to access your content using a CloudFront URL instead of the Amazon S3 URL. For more information about how to use origin access identities, see Serving Private Content through CloudFront in the Amazon CloudFront Developer Guide.

# Required Parameters
- `CloudFrontOriginAccessIdentityConfig`: The current configuration information for the identity.

"""

create_cloud_front_origin_access_identity2020_05_31(CloudFrontOriginAccessIdentityConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/origin-access-identity/cloudfront", Dict{String, Any}("CloudFrontOriginAccessIdentityConfig"=>CloudFrontOriginAccessIdentityConfig); aws_config=aws_config)
create_cloud_front_origin_access_identity2020_05_31(CloudFrontOriginAccessIdentityConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/origin-access-identity/cloudfront", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("CloudFrontOriginAccessIdentityConfig"=>CloudFrontOriginAccessIdentityConfig), args)); aws_config=aws_config)

"""
    CreateDistribution2020_05_31()

Creates a new web distribution. You create a CloudFront distribution to tell CloudFront where you want content to be delivered from, and the details about how to track and manage content delivery. Send a POST request to the /CloudFront API version/distribution/distribution ID resource.  When you update a distribution, there are more required fields than when you create a distribution. When you update your distribution by using UpdateDistribution, follow the steps included in the documentation to get the current configuration and then make your updates. This helps to make sure that you include all of the required fields. To view a summary, see Required Fields for Create Distribution and Update Distribution in the Amazon CloudFront Developer Guide. 

# Required Parameters
- `DistributionConfig`: The distribution's configuration information.

"""

create_distribution2020_05_31(DistributionConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution", Dict{String, Any}("DistributionConfig"=>DistributionConfig); aws_config=aws_config)
create_distribution2020_05_31(DistributionConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("DistributionConfig"=>DistributionConfig), args)); aws_config=aws_config)

"""
    CreateDistributionWithTags2020_05_31()

Create a new distribution with tags.

# Required Parameters
- `DistributionConfigWithTags`: The distribution's configuration information. 

"""

create_distribution_with_tags2020_05_31(DistributionConfigWithTags; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution?WithTags", Dict{String, Any}("DistributionConfigWithTags"=>DistributionConfigWithTags); aws_config=aws_config)
create_distribution_with_tags2020_05_31(DistributionConfigWithTags, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution?WithTags", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("DistributionConfigWithTags"=>DistributionConfigWithTags), args)); aws_config=aws_config)

"""
    CreateFieldLevelEncryptionConfig2020_05_31()

Create a new field-level encryption configuration.

# Required Parameters
- `FieldLevelEncryptionConfig`: The request to create a new field-level encryption configuration.

"""

create_field_level_encryption_config2020_05_31(FieldLevelEncryptionConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/field-level-encryption", Dict{String, Any}("FieldLevelEncryptionConfig"=>FieldLevelEncryptionConfig); aws_config=aws_config)
create_field_level_encryption_config2020_05_31(FieldLevelEncryptionConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/field-level-encryption", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("FieldLevelEncryptionConfig"=>FieldLevelEncryptionConfig), args)); aws_config=aws_config)

"""
    CreateFieldLevelEncryptionProfile2020_05_31()

Create a field-level encryption profile.

# Required Parameters
- `FieldLevelEncryptionProfileConfig`: The request to create a field-level encryption profile.

"""

create_field_level_encryption_profile2020_05_31(FieldLevelEncryptionProfileConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/field-level-encryption-profile", Dict{String, Any}("FieldLevelEncryptionProfileConfig"=>FieldLevelEncryptionProfileConfig); aws_config=aws_config)
create_field_level_encryption_profile2020_05_31(FieldLevelEncryptionProfileConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/field-level-encryption-profile", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("FieldLevelEncryptionProfileConfig"=>FieldLevelEncryptionProfileConfig), args)); aws_config=aws_config)

"""
    CreateInvalidation2020_05_31()

Create a new invalidation. 

# Required Parameters
- `DistributionId`: The distribution's id.
- `InvalidationBatch`: The batch information for the invalidation.

"""

create_invalidation2020_05_31(DistributionId, InvalidationBatch; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution/$(DistributionId)/invalidation", Dict{String, Any}("InvalidationBatch"=>InvalidationBatch); aws_config=aws_config)
create_invalidation2020_05_31(DistributionId, InvalidationBatch, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distribution/$(DistributionId)/invalidation", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("InvalidationBatch"=>InvalidationBatch), args)); aws_config=aws_config)

"""
    CreateMonitoringSubscription2020_05_31()

Enables additional CloudWatch metrics for the specified CloudFront distribution. The additional metrics incur an additional cost. For more information, see Viewing additional CloudFront distribution metrics in the Amazon CloudFront Developer Guide.

# Required Parameters
- `DistributionId`: The ID of the distribution that you are enabling metrics for.
- `MonitoringSubscription`: A monitoring subscription. This structure contains information about whether additional CloudWatch metrics are enabled for a given CloudFront distribution.

"""

create_monitoring_subscription2020_05_31(DistributionId, MonitoringSubscription; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription", Dict{String, Any}("MonitoringSubscription"=>MonitoringSubscription); aws_config=aws_config)
create_monitoring_subscription2020_05_31(DistributionId, MonitoringSubscription, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("MonitoringSubscription"=>MonitoringSubscription), args)); aws_config=aws_config)

"""
    CreateOriginRequestPolicy2020_05_31()

Creates an origin request policy. After you create an origin request policy, you can attach it to one or more cache behaviors. When it’s attached to a cache behavior, the origin request policy determines the values that CloudFront includes in requests that it sends to the origin. Each request that CloudFront sends to the origin includes the following:   The request body and the URL path (without the domain name) from the viewer request.   The headers that CloudFront automatically includes in every origin request, including Host, User-Agent, and X-Amz-Cf-Id.   All HTTP headers, cookies, and URL query strings that are specified in the cache policy or the origin request policy. These can include items from the viewer request and, in the case of headers, additional ones that are added by CloudFront.   CloudFront sends a request when it can’t find a valid object in its cache that matches the request. If you want to send values to the origin and also include them in the cache key, use CachePolicy. For more information about origin request policies, see Controlling origin requests in the Amazon CloudFront Developer Guide.

# Required Parameters
- `OriginRequestPolicyConfig`: An origin request policy configuration.

"""

create_origin_request_policy2020_05_31(OriginRequestPolicyConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/origin-request-policy", Dict{String, Any}("OriginRequestPolicyConfig"=>OriginRequestPolicyConfig); aws_config=aws_config)
create_origin_request_policy2020_05_31(OriginRequestPolicyConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/origin-request-policy", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("OriginRequestPolicyConfig"=>OriginRequestPolicyConfig), args)); aws_config=aws_config)

"""
    CreatePublicKey2020_05_31()

Add a new public key to CloudFront to use, for example, for field-level encryption. You can add a maximum of 10 public keys with one AWS account.

# Required Parameters
- `PublicKeyConfig`: The request to add a public key to CloudFront.

"""

create_public_key2020_05_31(PublicKeyConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/public-key", Dict{String, Any}("PublicKeyConfig"=>PublicKeyConfig); aws_config=aws_config)
create_public_key2020_05_31(PublicKeyConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/public-key", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("PublicKeyConfig"=>PublicKeyConfig), args)); aws_config=aws_config)

"""
    CreateRealtimeLogConfig2020_05_31()

Creates a real-time log configuration. After you create a real-time log configuration, you can attach it to one or more cache behaviors to send real-time log data to the specified Amazon Kinesis data stream. For more information about real-time log configurations, see Real-time logs in the Amazon CloudFront Developer Guide.

# Required Parameters
- `EndPoints`: Contains information about the Amazon Kinesis data stream where you are sending real-time log data.
- `Field`: A list of fields to include in each real-time log record. For more information about fields, see Real-time log configuration fields in the Amazon CloudFront Developer Guide.
- `Name`: A unique name to identify this real-time log configuration.
- `SamplingRate`: The sampling rate for this real-time log configuration. The sampling rate determines the percentage of viewer requests that are represented in the real-time log data. You must provide an integer between 1 and 100, inclusive.

# Optional Parameters
- `Fields`: A list of fields to include in each real-time log record. For more information about fields, see Real-time log configuration fields in the Amazon CloudFront Developer Guide.
"""

create_realtime_log_config2020_05_31(EndPoints, Field, Name, SamplingRate; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/realtime-log-config", Dict{String, Any}("EndPoints"=>EndPoints, "Field"=>Field, "Name"=>Name, "SamplingRate"=>SamplingRate); aws_config=aws_config)
create_realtime_log_config2020_05_31(EndPoints, Field, Name, SamplingRate, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/realtime-log-config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("EndPoints"=>EndPoints, "Field"=>Field, "Name"=>Name, "SamplingRate"=>SamplingRate), args)); aws_config=aws_config)

"""
    CreateStreamingDistribution2020_05_31()

Creates a new RTMP distribution. An RTMP distribution is similar to a web distribution, but an RTMP distribution streams media files using the Adobe Real-Time Messaging Protocol (RTMP) instead of serving files using HTTP.  To create a new distribution, submit a POST request to the CloudFront API version/distribution resource. The request body must include a document with a StreamingDistributionConfig element. The response echoes the StreamingDistributionConfig element and returns other information about the RTMP distribution. To get the status of your request, use the GET StreamingDistribution API action. When the value of Enabled is true and the value of Status is Deployed, your distribution is ready. A distribution usually deploys in less than 15 minutes. For more information about web distributions, see Working with RTMP Distributions in the Amazon CloudFront Developer Guide.  Beginning with the 2012-05-05 version of the CloudFront API, we made substantial changes to the format of the XML document that you include in the request body when you create or update a web distribution or an RTMP distribution, and when you invalidate objects. With previous versions of the API, we discovered that it was too easy to accidentally delete one or more values for an element that accepts multiple values, for example, CNAMEs and trusted signers. Our changes for the 2012-05-05 release are intended to prevent these accidental deletions and to notify you when there's a mismatch between the number of values you say you're specifying in the Quantity element and the number of values specified. 

# Required Parameters
- `StreamingDistributionConfig`: The streaming distribution's configuration information.

"""

create_streaming_distribution2020_05_31(StreamingDistributionConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/streaming-distribution", Dict{String, Any}("StreamingDistributionConfig"=>StreamingDistributionConfig); aws_config=aws_config)
create_streaming_distribution2020_05_31(StreamingDistributionConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/streaming-distribution", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("StreamingDistributionConfig"=>StreamingDistributionConfig), args)); aws_config=aws_config)

"""
    CreateStreamingDistributionWithTags2020_05_31()

Create a new streaming distribution with tags.

# Required Parameters
- `StreamingDistributionConfigWithTags`:  The streaming distribution's configuration information. 

"""

create_streaming_distribution_with_tags2020_05_31(StreamingDistributionConfigWithTags; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/streaming-distribution?WithTags", Dict{String, Any}("StreamingDistributionConfigWithTags"=>StreamingDistributionConfigWithTags); aws_config=aws_config)
create_streaming_distribution_with_tags2020_05_31(StreamingDistributionConfigWithTags, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/streaming-distribution?WithTags", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("StreamingDistributionConfigWithTags"=>StreamingDistributionConfigWithTags), args)); aws_config=aws_config)

"""
    DeleteCachePolicy2020_05_31()

Deletes a cache policy. You cannot delete a cache policy if it’s attached to a cache behavior. First update your distributions to remove the cache policy from all cache behaviors, then delete the cache policy. To delete a cache policy, you must provide the policy’s identifier and version. To get these values, you can use ListCachePolicies or GetCachePolicy.

# Required Parameters
- `Id`: The unique identifier for the cache policy that you are deleting. To get the identifier, you can use ListCachePolicies.

# Optional Parameters
- `If-Match`: The version of the cache policy that you are deleting. The version is the cache policy’s ETag value, which you can get using ListCachePolicies, GetCachePolicy, or GetCachePolicyConfig.
"""

delete_cache_policy2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/cache-policy/$(Id)"; aws_config=aws_config)
delete_cache_policy2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/cache-policy/$(Id)", args; aws_config=aws_config)

"""
    DeleteCloudFrontOriginAccessIdentity2020_05_31()

Delete an origin access identity. 

# Required Parameters
- `Id`: The origin access identity's ID.

# Optional Parameters
- `If-Match`: The value of the ETag header you received from a previous GET or PUT request. For example: E2QWRUHAPOMQZL.
"""

delete_cloud_front_origin_access_identity2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/origin-access-identity/cloudfront/$(Id)"; aws_config=aws_config)
delete_cloud_front_origin_access_identity2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/origin-access-identity/cloudfront/$(Id)", args; aws_config=aws_config)

"""
    DeleteDistribution2020_05_31()

Delete a distribution. 

# Required Parameters
- `Id`: The distribution ID. 

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when you disabled the distribution. For example: E2QWRUHAPOMQZL. 
"""

delete_distribution2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/distribution/$(Id)"; aws_config=aws_config)
delete_distribution2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/distribution/$(Id)", args; aws_config=aws_config)

"""
    DeleteFieldLevelEncryptionConfig2020_05_31()

Remove a field-level encryption configuration.

# Required Parameters
- `Id`: The ID of the configuration you want to delete from CloudFront.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the configuration identity to delete. For example: E2QWRUHAPOMQZL.
"""

delete_field_level_encryption_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/field-level-encryption/$(Id)"; aws_config=aws_config)
delete_field_level_encryption_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/field-level-encryption/$(Id)", args; aws_config=aws_config)

"""
    DeleteFieldLevelEncryptionProfile2020_05_31()

Remove a field-level encryption profile.

# Required Parameters
- `Id`: Request the ID of the profile you want to delete from CloudFront.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the profile to delete. For example: E2QWRUHAPOMQZL.
"""

delete_field_level_encryption_profile2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/field-level-encryption-profile/$(Id)"; aws_config=aws_config)
delete_field_level_encryption_profile2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/field-level-encryption-profile/$(Id)", args; aws_config=aws_config)

"""
    DeleteMonitoringSubscription2020_05_31()

Disables additional CloudWatch metrics for the specified CloudFront distribution.

# Required Parameters
- `DistributionId`: The ID of the distribution that you are disabling metrics for.

"""

delete_monitoring_subscription2020_05_31(DistributionId; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription"; aws_config=aws_config)
delete_monitoring_subscription2020_05_31(DistributionId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription", args; aws_config=aws_config)

"""
    DeleteOriginRequestPolicy2020_05_31()

Deletes an origin request policy. You cannot delete an origin request policy if it’s attached to any cache behaviors. First update your distributions to remove the origin request policy from all cache behaviors, then delete the origin request policy. To delete an origin request policy, you must provide the policy’s identifier and version. To get the identifier, you can use ListOriginRequestPolicies or GetOriginRequestPolicy.

# Required Parameters
- `Id`: The unique identifier for the origin request policy that you are deleting. To get the identifier, you can use ListOriginRequestPolicies.

# Optional Parameters
- `If-Match`: The version of the origin request policy that you are deleting. The version is the origin request policy’s ETag value, which you can get using ListOriginRequestPolicies, GetOriginRequestPolicy, or GetOriginRequestPolicyConfig.
"""

delete_origin_request_policy2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/origin-request-policy/$(Id)"; aws_config=aws_config)
delete_origin_request_policy2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/origin-request-policy/$(Id)", args; aws_config=aws_config)

"""
    DeletePublicKey2020_05_31()

Remove a public key you previously added to CloudFront.

# Required Parameters
- `Id`: The ID of the public key you want to remove from CloudFront.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the public key identity to delete. For example: E2QWRUHAPOMQZL.
"""

delete_public_key2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/public-key/$(Id)"; aws_config=aws_config)
delete_public_key2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/public-key/$(Id)", args; aws_config=aws_config)

"""
    DeleteRealtimeLogConfig2020_05_31()

Deletes a real-time log configuration. You cannot delete a real-time log configuration if it’s attached to a cache behavior. First update your distributions to remove the real-time log configuration from all cache behaviors, then delete the real-time log configuration. To delete a real-time log configuration, you can provide the configuration’s name or its Amazon Resource Name (ARN). You must provide at least one. If you provide both, CloudFront uses the name to identify the real-time log configuration to delete.

# Optional Parameters
- `ARN`: The Amazon Resource Name (ARN) of the real-time log configuration to delete.
- `Name`: The name of the real-time log configuration to delete.
"""

delete_realtime_log_config2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/delete-realtime-log-config/"; aws_config=aws_config)
delete_realtime_log_config2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/delete-realtime-log-config/", args; aws_config=aws_config)

"""
    DeleteStreamingDistribution2020_05_31()

Delete a streaming distribution. To delete an RTMP distribution using the CloudFront API, perform the following steps.  To delete an RTMP distribution using the CloudFront API:   Disable the RTMP distribution.   Submit a GET Streaming Distribution Config request to get the current configuration and the Etag header for the distribution.    Update the XML document that was returned in the response to your GET Streaming Distribution Config request to change the value of Enabled to false.   Submit a PUT Streaming Distribution Config request to update the configuration for your distribution. In the request body, include the XML document that you updated in Step 3. Then set the value of the HTTP If-Match header to the value of the ETag header that CloudFront returned when you submitted the GET Streaming Distribution Config request in Step 2.   Review the response to the PUT Streaming Distribution Config request to confirm that the distribution was successfully disabled.   Submit a GET Streaming Distribution Config request to confirm that your changes have propagated. When propagation is complete, the value of Status is Deployed.   Submit a DELETE Streaming Distribution request. Set the value of the HTTP If-Match header to the value of the ETag header that CloudFront returned when you submitted the GET Streaming Distribution Config request in Step 2.   Review the response to your DELETE Streaming Distribution request to confirm that the distribution was successfully deleted.   For information about deleting a distribution using the CloudFront console, see Deleting a Distribution in the Amazon CloudFront Developer Guide.

# Required Parameters
- `Id`: The distribution ID. 

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when you disabled the streaming distribution. For example: E2QWRUHAPOMQZL.
"""

delete_streaming_distribution2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/streaming-distribution/$(Id)"; aws_config=aws_config)
delete_streaming_distribution2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("DELETE", "/2020-05-31/streaming-distribution/$(Id)", args; aws_config=aws_config)

"""
    GetCachePolicy2020_05_31()

Gets a cache policy, including the following metadata:   The policy’s identifier.   The date and time when the policy was last modified.   To get a cache policy, you must provide the policy’s identifier. If the cache policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the cache policy is not attached to a cache behavior, you can get the identifier using ListCachePolicies.

# Required Parameters
- `Id`: The unique identifier for the cache policy. If the cache policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the cache policy is not attached to a cache behavior, you can get the identifier using ListCachePolicies.

"""

get_cache_policy2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy/$(Id)"; aws_config=aws_config)
get_cache_policy2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy/$(Id)", args; aws_config=aws_config)

"""
    GetCachePolicyConfig2020_05_31()

Gets a cache policy configuration. To get a cache policy configuration, you must provide the policy’s identifier. If the cache policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the cache policy is not attached to a cache behavior, you can get the identifier using ListCachePolicies.

# Required Parameters
- `Id`: The unique identifier for the cache policy. If the cache policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the cache policy is not attached to a cache behavior, you can get the identifier using ListCachePolicies.

"""

get_cache_policy_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy/$(Id)/config"; aws_config=aws_config)
get_cache_policy_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy/$(Id)/config", args; aws_config=aws_config)

"""
    GetCloudFrontOriginAccessIdentity2020_05_31()

Get the information about an origin access identity. 

# Required Parameters
- `Id`: The identity's ID.

"""

get_cloud_front_origin_access_identity2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront/$(Id)"; aws_config=aws_config)
get_cloud_front_origin_access_identity2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront/$(Id)", args; aws_config=aws_config)

"""
    GetCloudFrontOriginAccessIdentityConfig2020_05_31()

Get the configuration information about an origin access identity. 

# Required Parameters
- `Id`: The identity's ID. 

"""

get_cloud_front_origin_access_identity_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config"; aws_config=aws_config)
get_cloud_front_origin_access_identity_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config", args; aws_config=aws_config)

"""
    GetDistribution2020_05_31()

Get the information about a distribution.

# Required Parameters
- `Id`: The distribution's ID. If the ID is empty, an empty distribution configuration is returned.

"""

get_distribution2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(Id)"; aws_config=aws_config)
get_distribution2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(Id)", args; aws_config=aws_config)

"""
    GetDistributionConfig2020_05_31()

Get the configuration information about a distribution. 

# Required Parameters
- `Id`: The distribution's ID. If the ID is empty, an empty distribution configuration is returned.

"""

get_distribution_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(Id)/config"; aws_config=aws_config)
get_distribution_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(Id)/config", args; aws_config=aws_config)

"""
    GetFieldLevelEncryption2020_05_31()

Get the field-level encryption configuration information.

# Required Parameters
- `Id`: Request the ID for the field-level encryption configuration information.

"""

get_field_level_encryption2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption/$(Id)"; aws_config=aws_config)
get_field_level_encryption2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption/$(Id)", args; aws_config=aws_config)

"""
    GetFieldLevelEncryptionConfig2020_05_31()

Get the field-level encryption configuration information.

# Required Parameters
- `Id`: Request the ID for the field-level encryption configuration information.

"""

get_field_level_encryption_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption/$(Id)/config"; aws_config=aws_config)
get_field_level_encryption_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption/$(Id)/config", args; aws_config=aws_config)

"""
    GetFieldLevelEncryptionProfile2020_05_31()

Get the field-level encryption profile information.

# Required Parameters
- `Id`: Get the ID for the field-level encryption profile information.

"""

get_field_level_encryption_profile2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile/$(Id)"; aws_config=aws_config)
get_field_level_encryption_profile2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile/$(Id)", args; aws_config=aws_config)

"""
    GetFieldLevelEncryptionProfileConfig2020_05_31()

Get the field-level encryption profile configuration information.

# Required Parameters
- `Id`: Get the ID for the field-level encryption profile configuration information.

"""

get_field_level_encryption_profile_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile/$(Id)/config"; aws_config=aws_config)
get_field_level_encryption_profile_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile/$(Id)/config", args; aws_config=aws_config)

"""
    GetInvalidation2020_05_31()

Get the information about an invalidation. 

# Required Parameters
- `DistributionId`: The distribution's ID.
- `Id`: The identifier for the invalidation request, for example, IDFDVBD632BHDS5.

"""

get_invalidation2020_05_31(DistributionId, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(DistributionId)/invalidation/$(Id)"; aws_config=aws_config)
get_invalidation2020_05_31(DistributionId, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(DistributionId)/invalidation/$(Id)", args; aws_config=aws_config)

"""
    GetMonitoringSubscription2020_05_31()

Gets information about whether additional CloudWatch metrics are enabled for the specified CloudFront distribution.

# Required Parameters
- `DistributionId`: The ID of the distribution that you are getting metrics information for.

"""

get_monitoring_subscription2020_05_31(DistributionId; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription"; aws_config=aws_config)
get_monitoring_subscription2020_05_31(DistributionId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription", args; aws_config=aws_config)

"""
    GetOriginRequestPolicy2020_05_31()

Gets an origin request policy, including the following metadata:   The policy’s identifier.   The date and time when the policy was last modified.   To get an origin request policy, you must provide the policy’s identifier. If the origin request policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the origin request policy is not attached to a cache behavior, you can get the identifier using ListOriginRequestPolicies.

# Required Parameters
- `Id`: The unique identifier for the origin request policy. If the origin request policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the origin request policy is not attached to a cache behavior, you can get the identifier using ListOriginRequestPolicies.

"""

get_origin_request_policy2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy/$(Id)"; aws_config=aws_config)
get_origin_request_policy2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy/$(Id)", args; aws_config=aws_config)

"""
    GetOriginRequestPolicyConfig2020_05_31()

Gets an origin request policy configuration. To get an origin request policy configuration, you must provide the policy’s identifier. If the origin request policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the origin request policy is not attached to a cache behavior, you can get the identifier using ListOriginRequestPolicies.

# Required Parameters
- `Id`: The unique identifier for the origin request policy. If the origin request policy is attached to a distribution’s cache behavior, you can get the policy’s identifier using ListDistributions or GetDistribution. If the origin request policy is not attached to a cache behavior, you can get the identifier using ListOriginRequestPolicies.

"""

get_origin_request_policy_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy/$(Id)/config"; aws_config=aws_config)
get_origin_request_policy_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy/$(Id)/config", args; aws_config=aws_config)

"""
    GetPublicKey2020_05_31()

Get the public key information.

# Required Parameters
- `Id`: Request the ID for the public key.

"""

get_public_key2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key/$(Id)"; aws_config=aws_config)
get_public_key2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key/$(Id)", args; aws_config=aws_config)

"""
    GetPublicKeyConfig2020_05_31()

Return public key configuration informaation

# Required Parameters
- `Id`: Request the ID for the public key configuration.

"""

get_public_key_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key/$(Id)/config"; aws_config=aws_config)
get_public_key_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key/$(Id)/config", args; aws_config=aws_config)

"""
    GetRealtimeLogConfig2020_05_31()

Gets a real-time log configuration. To get a real-time log configuration, you can provide the configuration’s name or its Amazon Resource Name (ARN). You must provide at least one. If you provide both, CloudFront uses the name to identify the real-time log configuration to get.

# Optional Parameters
- `ARN`: The Amazon Resource Name (ARN) of the real-time log configuration to get.
- `Name`: The name of the real-time log configuration to get.
"""

get_realtime_log_config2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/get-realtime-log-config/"; aws_config=aws_config)
get_realtime_log_config2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/get-realtime-log-config/", args; aws_config=aws_config)

"""
    GetStreamingDistribution2020_05_31()

Gets information about a specified RTMP distribution, including the distribution configuration.

# Required Parameters
- `Id`: The streaming distribution's ID.

"""

get_streaming_distribution2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution/$(Id)"; aws_config=aws_config)
get_streaming_distribution2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution/$(Id)", args; aws_config=aws_config)

"""
    GetStreamingDistributionConfig2020_05_31()

Get the configuration information about a streaming distribution. 

# Required Parameters
- `Id`: The streaming distribution's ID.

"""

get_streaming_distribution_config2020_05_31(Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution/$(Id)/config"; aws_config=aws_config)
get_streaming_distribution_config2020_05_31(Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution/$(Id)/config", args; aws_config=aws_config)

"""
    ListCachePolicies2020_05_31()

Gets a list of cache policies. You can optionally apply a filter to return only the managed policies created by AWS, or only the custom policies created in your AWS account. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request.

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of cache policies. The response includes cache policies in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of cache policies that you want in the response.
- `Type`: A filter to return only the specified kinds of cache policies. Valid values are:    managed – Returns only the managed policies created by AWS.    custom – Returns only the custom policies created in your AWS account.  
"""

list_cache_policies2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy"; aws_config=aws_config)
list_cache_policies2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/cache-policy", args; aws_config=aws_config)

"""
    ListCloudFrontOriginAccessIdentities2020_05_31()

Lists origin access identities.

# Optional Parameters
- `Marker`: Use this when paginating results to indicate where to begin in your list of origin access identities. The results include identities in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page's response (which is also the ID of the last identity on that page).
- `MaxItems`: The maximum number of origin access identities you want in the response body. 
"""

list_cloud_front_origin_access_identities2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront"; aws_config=aws_config)
list_cloud_front_origin_access_identities2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-access-identity/cloudfront", args; aws_config=aws_config)

"""
    ListDistributions2020_05_31()

List CloudFront distributions.

# Optional Parameters
- `Marker`: Use this when paginating results to indicate where to begin in your list of distributions. The results include distributions in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page's response (which is also the ID of the last distribution on that page).
- `MaxItems`: The maximum number of distributions you want in the response body.
"""

list_distributions2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution"; aws_config=aws_config)
list_distributions2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution", args; aws_config=aws_config)

"""
    ListDistributionsByCachePolicyId2020_05_31()

Gets a list of distribution IDs for distributions that have a cache behavior that’s associated with the specified cache policy. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request.

# Required Parameters
- `CachePolicyId`: The ID of the cache policy whose associated distribution IDs you want to list.

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of distribution IDs. The response includes distribution IDs in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of distribution IDs that you want in the response.
"""

list_distributions_by_cache_policy_id2020_05_31(CachePolicyId; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByCachePolicyId/$(CachePolicyId)"; aws_config=aws_config)
list_distributions_by_cache_policy_id2020_05_31(CachePolicyId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByCachePolicyId/$(CachePolicyId)", args; aws_config=aws_config)

"""
    ListDistributionsByOriginRequestPolicyId2020_05_31()

Gets a list of distribution IDs for distributions that have a cache behavior that’s associated with the specified origin request policy. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request.

# Required Parameters
- `OriginRequestPolicyId`: The ID of the origin request policy whose associated distribution IDs you want to list.

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of distribution IDs. The response includes distribution IDs in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of distribution IDs that you want in the response.
"""

list_distributions_by_origin_request_policy_id2020_05_31(OriginRequestPolicyId; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByOriginRequestPolicyId/$(OriginRequestPolicyId)"; aws_config=aws_config)
list_distributions_by_origin_request_policy_id2020_05_31(OriginRequestPolicyId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByOriginRequestPolicyId/$(OriginRequestPolicyId)", args; aws_config=aws_config)

"""
    ListDistributionsByRealtimeLogConfig2020_05_31()

Gets a list of distributions that have a cache behavior that’s associated with the specified real-time log configuration. You can specify the real-time log configuration by its name or its Amazon Resource Name (ARN). You must provide at least one. If you provide both, CloudFront uses the name to identify the real-time log configuration to list distributions for. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request. 

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of distributions. The response includes distributions in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of distributions that you want in the response.
- `RealtimeLogConfigArn`: The Amazon Resource Name (ARN) of the real-time log configuration whose associated distributions you want to list.
- `RealtimeLogConfigName`: The name of the real-time log configuration whose associated distributions you want to list.
"""

list_distributions_by_realtime_log_config2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distributionsByRealtimeLogConfig/"; aws_config=aws_config)
list_distributions_by_realtime_log_config2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/distributionsByRealtimeLogConfig/", args; aws_config=aws_config)

"""
    ListDistributionsByWebACLId2020_05_31()

List the distributions that are associated with a specified AWS WAF web ACL. 

# Required Parameters
- `WebACLId`: The ID of the AWS WAF web ACL that you want to list the associated distributions. If you specify \"null\" for the ID, the request returns a list of the distributions that aren't associated with a web ACL. 

# Optional Parameters
- `Marker`: Use Marker and MaxItems to control pagination of results. If you have more than MaxItems distributions that satisfy the request, the response includes a NextMarker element. To get the next page of results, submit another request. For the value of Marker, specify the value of NextMarker from the last response. (For the first request, omit Marker.) 
- `MaxItems`: The maximum number of distributions that you want CloudFront to return in the response body. The maximum and default values are both 100.
"""

list_distributions_by_web_aclid2020_05_31(WebACLId; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByWebACLId/$(WebACLId)"; aws_config=aws_config)
list_distributions_by_web_aclid2020_05_31(WebACLId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distributionsByWebACLId/$(WebACLId)", args; aws_config=aws_config)

"""
    ListFieldLevelEncryptionConfigs2020_05_31()

List all field-level encryption configurations that have been created in CloudFront for this account.

# Optional Parameters
- `Marker`: Use this when paginating results to indicate where to begin in your list of configurations. The results include configurations in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page's response (which is also the ID of the last configuration on that page). 
- `MaxItems`: The maximum number of field-level encryption configurations you want in the response body. 
"""

list_field_level_encryption_configs2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption"; aws_config=aws_config)
list_field_level_encryption_configs2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption", args; aws_config=aws_config)

"""
    ListFieldLevelEncryptionProfiles2020_05_31()

Request a list of field-level encryption profiles that have been created in CloudFront for this account.

# Optional Parameters
- `Marker`: Use this when paginating results to indicate where to begin in your list of profiles. The results include profiles in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page's response (which is also the ID of the last profile on that page). 
- `MaxItems`: The maximum number of field-level encryption profiles you want in the response body. 
"""

list_field_level_encryption_profiles2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile"; aws_config=aws_config)
list_field_level_encryption_profiles2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/field-level-encryption-profile", args; aws_config=aws_config)

"""
    ListInvalidations2020_05_31()

Lists invalidation batches. 

# Required Parameters
- `DistributionId`: The distribution's ID.

# Optional Parameters
- `Marker`: Use this parameter when paginating results to indicate where to begin in your list of invalidation batches. Because the results are returned in decreasing order from most recent to oldest, the most recent results are on the first page, the second page will contain earlier results, and so on. To get the next page of results, set Marker to the value of the NextMarker from the current page's response. This value is the same as the ID of the last invalidation batch on that page. 
- `MaxItems`: The maximum number of invalidation batches that you want in the response body.
"""

list_invalidations2020_05_31(DistributionId; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(DistributionId)/invalidation"; aws_config=aws_config)
list_invalidations2020_05_31(DistributionId, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/distribution/$(DistributionId)/invalidation", args; aws_config=aws_config)

"""
    ListOriginRequestPolicies2020_05_31()

Gets a list of origin request policies. You can optionally apply a filter to return only the managed policies created by AWS, or only the custom policies created in your AWS account. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request.

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of origin request policies. The response includes origin request policies in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of origin request policies that you want in the response.
- `Type`: A filter to return only the specified kinds of origin request policies. Valid values are:    managed – Returns only the managed policies created by AWS.    custom – Returns only the custom policies created in your AWS account.  
"""

list_origin_request_policies2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy"; aws_config=aws_config)
list_origin_request_policies2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/origin-request-policy", args; aws_config=aws_config)

"""
    ListPublicKeys2020_05_31()

List all public keys that have been added to CloudFront for this account.

# Optional Parameters
- `Marker`: Use this when paginating results to indicate where to begin in your list of public keys. The results include public keys in the list that occur after the marker. To get the next page of results, set the Marker to the value of the NextMarker from the current page's response (which is also the ID of the last public key on that page). 
- `MaxItems`: The maximum number of public keys you want in the response body. 
"""

list_public_keys2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key"; aws_config=aws_config)
list_public_keys2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/public-key", args; aws_config=aws_config)

"""
    ListRealtimeLogConfigs2020_05_31()

Gets a list of real-time log configurations. You can optionally specify the maximum number of items to receive in the response. If the total number of items in the list exceeds the maximum that you specify, or the default maximum, the response is paginated. To get the next page of items, send a subsequent request that specifies the NextMarker value from the current response as the Marker value in the subsequent request. 

# Optional Parameters
- `Marker`: Use this field when paginating results to indicate where to begin in your list of real-time log configurations. The response includes real-time log configurations in the list that occur after the marker. To get the next page of the list, set this field’s value to the value of NextMarker from the current page’s response.
- `MaxItems`: The maximum number of real-time log configurations that you want in the response.
"""

list_realtime_log_configs2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/realtime-log-config"; aws_config=aws_config)
list_realtime_log_configs2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/realtime-log-config", args; aws_config=aws_config)

"""
    ListStreamingDistributions2020_05_31()

List streaming distributions. 

# Optional Parameters
- `Marker`: The value that you provided for the Marker request parameter.
- `MaxItems`: The value that you provided for the MaxItems request parameter.
"""

list_streaming_distributions2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution"; aws_config=aws_config)
list_streaming_distributions2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/streaming-distribution", args; aws_config=aws_config)

"""
    ListTagsForResource2020_05_31()

List tags for a CloudFront resource.

# Required Parameters
- `Resource`:  An ARN of a CloudFront resource.

"""

list_tags_for_resource2020_05_31(Resource; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/tagging", Dict{String, Any}("Resource"=>Resource); aws_config=aws_config)
list_tags_for_resource2020_05_31(Resource, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("GET", "/2020-05-31/tagging", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("Resource"=>Resource), args)); aws_config=aws_config)

"""
    TagResource2020_05_31()

Add tags to a CloudFront resource.

# Required Parameters
- `Resource`:  An ARN of a CloudFront resource.
- `Tags`:  A complex type that contains zero or more Tag elements.

"""

tag_resource2020_05_31(Resource, Tags; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/tagging?Operation=Tag", Dict{String, Any}("Resource"=>Resource, "Tags"=>Tags); aws_config=aws_config)
tag_resource2020_05_31(Resource, Tags, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/tagging?Operation=Tag", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("Resource"=>Resource, "Tags"=>Tags), args)); aws_config=aws_config)

"""
    UntagResource2020_05_31()

Remove tags from a CloudFront resource.

# Required Parameters
- `Resource`:  An ARN of a CloudFront resource.
- `TagKeys`:  A complex type that contains zero or more Tag key elements.

"""

untag_resource2020_05_31(Resource, TagKeys; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/tagging?Operation=Untag", Dict{String, Any}("Resource"=>Resource, "TagKeys"=>TagKeys); aws_config=aws_config)
untag_resource2020_05_31(Resource, TagKeys, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("POST", "/2020-05-31/tagging?Operation=Untag", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("Resource"=>Resource, "TagKeys"=>TagKeys), args)); aws_config=aws_config)

"""
    UpdateCachePolicy2020_05_31()

Updates a cache policy configuration. When you update a cache policy configuration, all the fields are updated with the values provided in the request. You cannot update some fields independent of others. To update a cache policy configuration:   Use GetCachePolicyConfig to get the current configuration.   Locally modify the fields in the cache policy configuration that you want to update.   Call UpdateCachePolicy by providing the entire cache policy configuration, including the fields that you modified and those that you didn’t.  

# Required Parameters
- `CachePolicyConfig`: A cache policy configuration.
- `Id`: The unique identifier for the cache policy that you are updating. The identifier is returned in a cache behavior’s CachePolicyId field in the response to GetDistributionConfig.

# Optional Parameters
- `If-Match`: The version of the cache policy that you are updating. The version is returned in the cache policy’s ETag field in the response to GetCachePolicyConfig.
"""

update_cache_policy2020_05_31(CachePolicyConfig, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/cache-policy/$(Id)", Dict{String, Any}("CachePolicyConfig"=>CachePolicyConfig); aws_config=aws_config)
update_cache_policy2020_05_31(CachePolicyConfig, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/cache-policy/$(Id)", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("CachePolicyConfig"=>CachePolicyConfig), args)); aws_config=aws_config)

"""
    UpdateCloudFrontOriginAccessIdentity2020_05_31()

Update an origin access identity. 

# Required Parameters
- `CloudFrontOriginAccessIdentityConfig`: The identity's configuration information.
- `Id`: The identity's id.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the identity's configuration. For example: E2QWRUHAPOMQZL.
"""

update_cloud_front_origin_access_identity2020_05_31(CloudFrontOriginAccessIdentityConfig, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config", Dict{String, Any}("CloudFrontOriginAccessIdentityConfig"=>CloudFrontOriginAccessIdentityConfig); aws_config=aws_config)
update_cloud_front_origin_access_identity2020_05_31(CloudFrontOriginAccessIdentityConfig, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("CloudFrontOriginAccessIdentityConfig"=>CloudFrontOriginAccessIdentityConfig), args)); aws_config=aws_config)

"""
    UpdateDistribution2020_05_31()

Updates the configuration for a web distribution.   When you update a distribution, there are more required fields than when you create a distribution. When you update your distribution by using this API action, follow the steps here to get the current configuration and then make your updates, to make sure that you include all of the required fields. To view a summary, see Required Fields for Create Distribution and Update Distribution in the Amazon CloudFront Developer Guide.  The update process includes getting the current distribution configuration, updating the XML document that is returned to make your changes, and then submitting an UpdateDistribution request to make the updates. For information about updating a distribution using the CloudFront console instead, see Creating a Distribution in the Amazon CloudFront Developer Guide.  To update a web distribution using the CloudFront API    Submit a GetDistributionConfig request to get the current configuration and an Etag header for the distribution.  If you update the distribution again, you must get a new Etag header.    Update the XML document that was returned in the response to your GetDistributionConfig request to include your changes.   When you edit the XML file, be aware of the following:   You must strip out the ETag parameter that is returned.   Additional fields are required when you update a distribution. There may be fields included in the XML file for features that you haven't configured for your distribution. This is expected and required to successfully update the distribution.   You can't change the value of CallerReference. If you try to change this value, CloudFront returns an IllegalUpdate error.    The new configuration replaces the existing configuration; the values that you specify in an UpdateDistribution request are not merged into your existing configuration. When you add, delete, or replace values in an element that allows multiple values (for example, CNAME), you must specify all of the values that you want to appear in the updated distribution. In addition, you must update the corresponding Quantity element.      Submit an UpdateDistribution request to update the configuration for your distribution:   In the request body, include the XML document that you updated in Step 2. The request body must include an XML document with a DistributionConfig element.   Set the value of the HTTP If-Match header to the value of the ETag header that CloudFront returned when you submitted the GetDistributionConfig request in Step 1.     Review the response to the UpdateDistribution request to confirm that the configuration was successfully updated.   Optional: Submit a GetDistribution request to confirm that your changes have propagated. When propagation is complete, the value of Status is Deployed.  

# Required Parameters
- `DistributionConfig`: The distribution's configuration information.
- `Id`: The distribution's id.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the distribution's configuration. For example: E2QWRUHAPOMQZL.
"""

update_distribution2020_05_31(DistributionConfig, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/distribution/$(Id)/config", Dict{String, Any}("DistributionConfig"=>DistributionConfig); aws_config=aws_config)
update_distribution2020_05_31(DistributionConfig, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/distribution/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("DistributionConfig"=>DistributionConfig), args)); aws_config=aws_config)

"""
    UpdateFieldLevelEncryptionConfig2020_05_31()

Update a field-level encryption configuration. 

# Required Parameters
- `FieldLevelEncryptionConfig`: Request to update a field-level encryption configuration. 
- `Id`: The ID of the configuration you want to update.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the configuration identity to update. For example: E2QWRUHAPOMQZL.
"""

update_field_level_encryption_config2020_05_31(FieldLevelEncryptionConfig, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/field-level-encryption/$(Id)/config", Dict{String, Any}("FieldLevelEncryptionConfig"=>FieldLevelEncryptionConfig); aws_config=aws_config)
update_field_level_encryption_config2020_05_31(FieldLevelEncryptionConfig, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/field-level-encryption/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("FieldLevelEncryptionConfig"=>FieldLevelEncryptionConfig), args)); aws_config=aws_config)

"""
    UpdateFieldLevelEncryptionProfile2020_05_31()

Update a field-level encryption profile. 

# Required Parameters
- `FieldLevelEncryptionProfileConfig`: Request to update a field-level encryption profile. 
- `Id`: The ID of the field-level encryption profile request. 

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the profile identity to update. For example: E2QWRUHAPOMQZL.
"""

update_field_level_encryption_profile2020_05_31(FieldLevelEncryptionProfileConfig, Id; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/field-level-encryption-profile/$(Id)/config", Dict{String, Any}("FieldLevelEncryptionProfileConfig"=>FieldLevelEncryptionProfileConfig); aws_config=aws_config)
update_field_level_encryption_profile2020_05_31(FieldLevelEncryptionProfileConfig, Id, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/field-level-encryption-profile/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("FieldLevelEncryptionProfileConfig"=>FieldLevelEncryptionProfileConfig), args)); aws_config=aws_config)

"""
    UpdateOriginRequestPolicy2020_05_31()

Updates an origin request policy configuration. When you update an origin request policy configuration, all the fields are updated with the values provided in the request. You cannot update some fields independent of others. To update an origin request policy configuration:   Use GetOriginRequestPolicyConfig to get the current configuration.   Locally modify the fields in the origin request policy configuration that you want to update.   Call UpdateOriginRequestPolicy by providing the entire origin request policy configuration, including the fields that you modified and those that you didn’t.  

# Required Parameters
- `Id`: The unique identifier for the origin request policy that you are updating. The identifier is returned in a cache behavior’s OriginRequestPolicyId field in the response to GetDistributionConfig.
- `OriginRequestPolicyConfig`: An origin request policy configuration.

# Optional Parameters
- `If-Match`: The version of the origin request policy that you are updating. The version is returned in the origin request policy’s ETag field in the response to GetOriginRequestPolicyConfig.
"""

update_origin_request_policy2020_05_31(Id, OriginRequestPolicyConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/origin-request-policy/$(Id)", Dict{String, Any}("OriginRequestPolicyConfig"=>OriginRequestPolicyConfig); aws_config=aws_config)
update_origin_request_policy2020_05_31(Id, OriginRequestPolicyConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/origin-request-policy/$(Id)", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("OriginRequestPolicyConfig"=>OriginRequestPolicyConfig), args)); aws_config=aws_config)

"""
    UpdatePublicKey2020_05_31()

Update public key information. Note that the only value you can change is the comment.

# Required Parameters
- `Id`: ID of the public key to be updated.
- `PublicKeyConfig`: Request to update public key information.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the public key to update. For example: E2QWRUHAPOMQZL.
"""

update_public_key2020_05_31(Id, PublicKeyConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/public-key/$(Id)/config", Dict{String, Any}("PublicKeyConfig"=>PublicKeyConfig); aws_config=aws_config)
update_public_key2020_05_31(Id, PublicKeyConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/public-key/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("PublicKeyConfig"=>PublicKeyConfig), args)); aws_config=aws_config)

"""
    UpdateRealtimeLogConfig2020_05_31()

Updates a real-time log configuration. When you update a real-time log configuration, all the parameters are updated with the values provided in the request. You cannot update some parameters independent of others. To update a real-time log configuration:   Call GetRealtimeLogConfig to get the current real-time log configuration.   Locally modify the parameters in the real-time log configuration that you want to update.   Call this API (UpdateRealtimeLogConfig) by providing the entire real-time log configuration, including the parameters that you modified and those that you didn’t.   You cannot update a real-time log configuration’s Name or ARN.

# Optional Parameters
- `ARN`: The Amazon Resource Name (ARN) for this real-time log configuration.
- `EndPoints`: Contains information about the Amazon Kinesis data stream where you are sending real-time log data.
- `Fields`: A list of fields to include in each real-time log record. For more information about fields, see Real-time log configuration fields in the Amazon CloudFront Developer Guide.
- `Name`: The name for this real-time log configuration.
- `SamplingRate`: The sampling rate for this real-time log configuration. The sampling rate determines the percentage of viewer requests that are represented in the real-time log data. You must provide an integer between 1 and 100, inclusive.
"""

update_realtime_log_config2020_05_31(; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/realtime-log-config/"; aws_config=aws_config)
update_realtime_log_config2020_05_31(args::AbstractDict{String, Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/realtime-log-config/", args; aws_config=aws_config)

"""
    UpdateStreamingDistribution2020_05_31()

Update a streaming distribution. 

# Required Parameters
- `Id`: The streaming distribution's id.
- `StreamingDistributionConfig`: The streaming distribution's configuration information.

# Optional Parameters
- `If-Match`: The value of the ETag header that you received when retrieving the streaming distribution's configuration. For example: E2QWRUHAPOMQZL.
"""

update_streaming_distribution2020_05_31(Id, StreamingDistributionConfig; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/streaming-distribution/$(Id)/config", Dict{String, Any}("StreamingDistributionConfig"=>StreamingDistributionConfig); aws_config=aws_config)
update_streaming_distribution2020_05_31(Id, StreamingDistributionConfig, args::AbstractDict{String, <:Any}; aws_config::AWSConfig=global_aws_config()) = cloudfront("PUT", "/2020-05-31/streaming-distribution/$(Id)/config", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("StreamingDistributionConfig"=>StreamingDistributionConfig), args)); aws_config=aws_config)
